from fonctions_utiles import *
from api import avancer,PTS_ACTION,trouver_chemin,info_nid, debug_poser_pigeon,pains
from api import pigeon_debug as Pigeon_debug


""" Un algo pas terrible
Cette première finale a surtout consisté à comprendre le fonctionnement de l'API,
et prendre les outils en main; je n'ai pas donc vraiment eu le temps de faire un truc
très réfléchi.

Le principe est simple: La mère va chercher un bout de pain et le ramène au nid,
et répète le processus indéfiniment. 

On pourrait améliorer:
 - Tenir compte des impasses: ou on les évite, ou on creuse...
 - Trouver un algorithme plus optimisé pour trouver le chemin le plus court (en passant par les trous/ barrières notamment)
 - Exploiter la possibilité de s'aggrandir
 - Être aussi aggressif: placer des buissons, couper la route...
"""

positions_pains = set()
papys = set()

def verif_impasse(x,y,carte):
    # Vérifie de manière récursive les impasses d'une carte
    if not carte[y][x]:
        if not est_case_libre((x,y,0)):
            carte[y][x] = True
        issues = 0
        if 0 <= x-1:
            issues += 1-carte[y][x-1]
        if 0 <= y-1:
            issues += 1-carte[y-1][x]
        if x+1 < LARGEUR:
            issues += 1-carte[y][x+1]
        if y+1 < HAUTEUR:
            issues += 1-carte[y+1][x]
    
        if issues < 2:
            carte[y][x] = True

def carte_cases_impasses():
    """ Renvoie la carte des cases qui mènent dans une impasse """
    map_impasse = [[(not est_case_libre((i,j,0))) for i in range(LARGEUR)] for j in range(HAUTEUR)]
    for i in range(LARGEUR):
        for j in range(HAUTEUR):
            if not map_impasse[j][i]:
                verif_impasse(i,j,map_impasse)
    [print(''.join([str(int(a)) for a in liste])) for liste in map_impasse]
    # 0 = pas encore vérifié, présumé non impasse, 1 = pas encore vérifié, présumé impasse
    # 2 = vérifié, pas impasse, 3 = vérifié, impasse


def maj_positions_pains():
    #print_as_me("maj_positions_pains début")
    global positions_pains,papys
    #papys -= set(pains())
    positions_pains &= set(pains())
    #position_pains |= papys
    #print_as_me("maj_positions_pains (fin)")

# Fonction appelée au début de la partie.
def partie_init():
    carte_cases_impasses()
    #print_as_me("partie_init début")
    global positions_pain,liste_cibles, liste_nids, NID_MOI
    if moi() == 0:
        NID_MOI = JOUEUR_0
    else:
        NID_MOI = JOUEUR_1
    positions_pain = set(trouve_cases(PAPY))
    liste_nids = [nid for nid in trouve_cases(NID) if info_nid(nid) in (NID_MOI,LIBRE)]
    liste_cibles = [troupes_joueur(moi())[i].maman for i in range(NB_TROUPES)]
    #print_as_me("partie_init (fin)")


def va_vers(id_troupe,cases):
    #print_as_me("va_vers début")
    """ Modifie la trajectoire d'une troupe pour qu'elle se dirige vers une case parmi les cases données """
    global liste_cibles, etape_deplacements
    troupe = troupes_joueur(moi())[id_troupe]
    destination_retenue = (-1,-1,-1)
    taille_min = 16001
    for destination in cases:
        chemin = trouver_chemin(troupe.maman,destination)
        l = len(chemin)
        if l != 0:
            if l < taille_min:
                #print_as_me("nouveau candidat:",chemin)
                liste_deplacements[id_troupe] = chemin
                etape_deplacements[id_troupe] = 0
                liste_cibles[id_troupe] = destination
                taille_min = l
                destination_retenue = destination
    #print_as_me("va_vers (fin)")

def survivre(troupe, nb_deplacements,):
    #print_as_me("survivre début")
    """ Évite la dispersion en faisant avancer la troupe dans la direction disponible. """
    for j in range(nb_deplacements):
        avance = False
        for direction in (NORD,SUD,EST,OUEST):
            if avance_si_possible(troupe, direction):
                avance = True
                break
    #print_as_me("survivre (fin)")

def avance_si_possible(troupe,direction):
    #print_as_me("avance_si_possible début")
    """ Fait avancer, si possible, la troupe dans la direction donnée """
    pos = troupe.maman
    id_troupe = troupe.id
    np = position_relative(pos,direction)
    if est_position_valide(np) and est_case_libre(np) and est_sans_canard(np):
        avancer(troupe.id,direction)
        return True
    else:
        return False
    #print_as_me("avance_si_possible (fin)")

def avance_selon_chemin(id_troupe):
    #print_as_me("avance_selon_chemin début")
    global etape_deplacements
    if etapes_deplacement[id_troupe] >= len(liste_deplacements[i]):
        survivre(troupe,1)
    else:
        if avance_si_possible(troupes_joueur(moi())[id_troupe],liste_deplacements[i][etape_deplacements[i]]):
            etape_deplacements[i] += 1
        else:
            grandir(troupes_joueurs(moi())[id_troupe].id)
    #print_as_me("avance_selon_chemin (fin)")

# Fonction appelée à chaque tour.
def jouer_tour():
    #print_as_me("jouer_tour début")
    global liste_cibles,positions_pains
    maj_positions_pains()
    if moi() == 0:
        PIGEON_COLOR = Pigeon_debug.PIGEON_ROUGE
    if moi() == 1:
        PIGEON_COLOR = Pigeon_debug.PIGEON_BLEU
    for i in range(NB_TROUPES):
        # On avance vers la cible; si on n'en a pas trouvé, on tente de vivre
        for j in range(PTS_ACTION):
            maman = troupes_joueur(moi())[i].maman
            # On définit la cible, si ça n'est pas fait
            if maman == liste_cibles[i]:
                if liste_cibles[i] in positions_pain:
                    va_vers(i,liste_nids)
                else:
                    va_vers(i,positions_pain)
                etape_deplacements[i] = 0
            debug_poser_pigeon(liste_cibles[i], PIGEON_COLOR)
            troupe = troupes_joueur(moi())[i]
            if etape_deplacements[i] == len(liste_deplacements[i]):
                survivre(troupe,1)
            else:
                avance_si_possible(troupe,liste_deplacements[i][etape_deplacements[i]])
                etape_deplacements[i] += 1
    #print_as_me("jouer_tour (fin)")


# Fonction appelée à la fin de la partie.
def partie_fin():
    # TODO
    pass
